from __future__ import annotations

from datetime import datetime
from typing import Any
from typing import Callable
from typing import Dict
from typing import IO
from typing import List
from typing import Union

from boto3.s3.transfer import TransferConfig
from botocore.client import BaseClient
from botocore.paginate import Paginator
from botocore.waiter import Waiter


class Client(BaseClient):

    # pylint: disable=arguments-differ
    def abort_multipart_upload(self) -> None:
        pass

    # pylint: disable=arguments-differ
    def can_paginate(self, operation_name: str = None) -> None:
        pass

    # pylint: disable=arguments-differ
    def complete_multipart_upload(
        self,
        Bucket: str,
        Key: str,
        UploadId: str,
        MultipartUpload: Dict[str, Any] = None,
        RequestPayer: str = None,
    ) -> Dict[str, Any]:
        pass

    # pylint: disable=arguments-differ
    def copy(
        self,
        CopySource: Dict[str, Any] = None,
        Bucket: str = None,
        Key: str = None,
        ExtraArgs: Dict[str, Any] = None,
        Callback: Callable[..., Any] = None,
        SourceClient: BaseClient = None,
        Config: TransferConfig = None,
    ) -> None:
        pass

    # pylint: disable=arguments-differ
    def copy_object(
        self,
        Bucket: str,
        CopySource: Union[str, Dict[Any, Any]],
        Key: str,
        ACL: str = None,
        CacheControl: str = None,
        ContentDisposition: str = None,
        ContentEncoding: str = None,
        ContentLanguage: str = None,
        ContentType: str = None,
        CopySourceIfMatch: str = None,
        CopySourceIfModifiedSince: datetime = None,
        CopySourceIfNoneMatch: str = None,
        CopySourceIfUnmodifiedSince: datetime = None,
        Expires: datetime = None,
        GrantFullControl: str = None,
        GrantRead: str = None,
        GrantReadACP: str = None,
        GrantWriteACP: str = None,
        Metadata: Dict[str, Any] = None,
        MetadataDirective: str = None,
        TaggingDirective: str = None,
        ServerSideEncryption: str = None,
        StorageClass: str = None,
        WebsiteRedirectLocation: str = None,
        SSECustomerAlgorithm: str = None,
        SSECustomerKey: str = None,
        SSECustomerKeyMD5: str = None,
        SSEKMSKeyId: str = None,
        SSEKMSEncryptionContext: str = None,
        CopySourceSSECustomerAlgorithm: str = None,
        CopySourceSSECustomerKey: str = None,
        CopySourceSSECustomerKeyMD5: str = None,
        RequestPayer: str = None,
        Tagging: str = None,
        ObjectLockMode: str = None,
        ObjectLockRetainUntilDate: datetime = None,
        ObjectLockLegalHoldStatus: str = None,
    ) -> Dict[str, Any]:
        pass

    # pylint: disable=arguments-differ
    def create_bucket(
        self,
        Bucket: str,
        ACL: str = None,
        CreateBucketConfiguration: Dict[str, Any] = None,
        GrantFullControl: str = None,
        GrantRead: str = None,
        GrantReadACP: str = None,
        GrantWrite: str = None,
        GrantWriteACP: str = None,
        ObjectLockEnabledForBucket: bool = None,
    ) -> Dict[str, Any]:
        pass

    # pylint: disable=arguments-differ
    def create_multipart_upload(
        self,
        Bucket: str,
        Key: str,
        ACL: str = None,
        CacheControl: str = None,
        ContentDisposition: str = None,
        ContentEncoding: str = None,
        ContentLanguage: str = None,
        ContentType: str = None,
        Expires: datetime = None,
        GrantFullControl: str = None,
        GrantRead: str = None,
        GrantReadACP: str = None,
        GrantWriteACP: str = None,
        Metadata: Dict[str, Any] = None,
        ServerSideEncryption: str = None,
        StorageClass: str = None,
        WebsiteRedirectLocation: str = None,
        SSECustomerAlgorithm: str = None,
        SSECustomerKey: str = None,
        SSECustomerKeyMD5: str = None,
        SSEKMSKeyId: str = None,
        SSEKMSEncryptionContext: str = None,
        RequestPayer: str = None,
        Tagging: str = None,
        ObjectLockMode: str = None,
        ObjectLockRetainUntilDate: datetime = None,
        ObjectLockLegalHoldStatus: str = None,
    ) -> Dict[str, Any]:
        pass

    # pylint: disable=arguments-differ
    def delete_bucket(self) -> None:
        pass

    # pylint: disable=arguments-differ
    def delete_bucket_analytics_configuration(self) -> None:
        pass

    # pylint: disable=arguments-differ
    def delete_bucket_cors(self) -> None:
        pass

    # pylint: disable=arguments-differ
    def delete_bucket_encryption(self) -> None:
        pass

    # pylint: disable=arguments-differ
    def delete_bucket_inventory_configuration(self) -> None:
        pass

    # pylint: disable=arguments-differ
    def delete_bucket_lifecycle(self) -> None:
        pass

    # pylint: disable=arguments-differ
    def delete_bucket_metrics_configuration(self) -> None:
        pass

    # pylint: disable=arguments-differ
    def delete_bucket_policy(self) -> None:
        pass

    # pylint: disable=arguments-differ
    def delete_bucket_replication(self) -> None:
        pass

    # pylint: disable=arguments-differ
    def delete_bucket_tagging(self) -> None:
        pass

    # pylint: disable=arguments-differ
    def delete_bucket_website(self) -> None:
        pass

    # pylint: disable=arguments-differ
    def delete_object(self) -> None:
        pass

    # pylint: disable=arguments-differ
    def delete_object_tagging(self) -> None:
        pass

    # pylint: disable=arguments-differ
    def delete_objects(
        self,
        Bucket: str,
        Delete: Dict[str, Any],
        MFA: str = None,
        RequestPayer: str = None,
        BypassGovernanceRetention: bool = None,
    ) -> Dict[str, Any]:
        pass

    # pylint: disable=arguments-differ
    def delete_public_access_block(self) -> None:
        pass

    # pylint: disable=arguments-differ
    def download_file(
        self,
        Bucket: str = None,
        Key: str = None,
        Filename: str = None,
        ExtraArgs: Dict[str, Any] = None,
        Callback: Callable[..., Any] = None,
        Config: TransferConfig = None,
    ) -> None:
        pass

    # pylint: disable=arguments-differ
    def download_fileobj(
        self,
        Fileobj: Union[Any] = None,
        Bucket: str = None,
        Key: str = None,
        ExtraArgs: Dict[str, Any] = None,
        Callback: Callable[..., Any] = None,
        Config: TransferConfig = None,
    ) -> None:
        pass

    # pylint: disable=arguments-differ
    def generate_presigned_post(
        self,
        Bucket: str = None,
        Key: str = None,
        Fields: Dict[str, Any] = None,
        Conditions: List[Any] = None,
        ExpiresIn: int = None,
    ) -> Dict[str, Any]:
        pass

    # pylint: disable=arguments-differ
    def generate_presigned_url(
        self,
        ClientMethod: str = None,
        Params: Dict[str, Any] = None,
        ExpiresIn: int = None,
        HttpMethod: str = None,
    ) -> None:
        pass

    # pylint: disable=arguments-differ
    def get_bucket_accelerate_configuration(self) -> None:
        pass

    # pylint: disable=arguments-differ
    def get_bucket_acl(self) -> None:
        pass

    # pylint: disable=arguments-differ
    def get_bucket_analytics_configuration(self) -> None:
        pass

    # pylint: disable=arguments-differ
    def get_bucket_cors(self) -> None:
        pass

    # pylint: disable=arguments-differ
    def get_bucket_encryption(self) -> None:
        pass

    # pylint: disable=arguments-differ
    def get_bucket_inventory_configuration(self) -> None:
        pass

    # pylint: disable=arguments-differ
    def get_bucket_lifecycle(self) -> None:
        pass

    # pylint: disable=arguments-differ
    def get_bucket_lifecycle_configuration(self) -> None:
        pass

    # pylint: disable=arguments-differ
    def get_bucket_location(self) -> None:
        pass

    # pylint: disable=arguments-differ
    def get_bucket_logging(self) -> None:
        pass

    # pylint: disable=arguments-differ
    def get_bucket_metrics_configuration(self) -> None:
        pass

    # pylint: disable=arguments-differ
    def get_bucket_notification(self) -> None:
        pass

    # pylint: disable=arguments-differ
    def get_bucket_notification_configuration(self) -> None:
        pass

    # pylint: disable=arguments-differ
    def get_bucket_policy(self) -> None:
        pass

    # pylint: disable=arguments-differ
    def get_bucket_policy_status(self) -> None:
        pass

    # pylint: disable=arguments-differ
    def get_bucket_replication(self) -> None:
        pass

    # pylint: disable=arguments-differ
    def get_bucket_request_payment(self) -> None:
        pass

    # pylint: disable=arguments-differ
    def get_bucket_tagging(self) -> None:
        pass

    # pylint: disable=arguments-differ
    def get_bucket_versioning(self) -> None:
        pass

    # pylint: disable=arguments-differ
    def get_bucket_website(self) -> None:
        pass

    # pylint: disable=arguments-differ
    def get_object(self) -> None:
        pass

    # pylint: disable=arguments-differ
    def get_object_acl(self) -> None:
        pass

    # pylint: disable=arguments-differ
    def get_object_legal_hold(self) -> None:
        pass

    # pylint: disable=arguments-differ
    def get_object_lock_configuration(self) -> None:
        pass

    # pylint: disable=arguments-differ
    def get_object_retention(self) -> None:
        pass

    # pylint: disable=arguments-differ
    def get_object_tagging(self) -> None:
        pass

    # pylint: disable=arguments-differ
    def get_object_torrent(self) -> None:
        pass

    # pylint: disable=arguments-differ
    def get_paginator(self, operation_name: str = None) -> Paginator:
        pass

    # pylint: disable=arguments-differ
    def get_public_access_block(self) -> None:
        pass

    # pylint: disable=arguments-differ
    def get_waiter(self, waiter_name: str = None) -> Waiter:
        pass

    # pylint: disable=arguments-differ
    def head_bucket(self) -> None:
        pass

    # pylint: disable=arguments-differ
    def head_object(self) -> None:
        pass

    # pylint: disable=arguments-differ
    def list_bucket_analytics_configurations(self) -> None:
        pass

    # pylint: disable=arguments-differ
    def list_bucket_inventory_configurations(self) -> None:
        pass

    # pylint: disable=arguments-differ
    def list_bucket_metrics_configurations(self) -> None:
        pass

    # pylint: disable=arguments-differ
    def list_buckets(self) -> None:
        pass

    # pylint: disable=arguments-differ
    def list_multipart_uploads(self) -> None:
        pass

    # pylint: disable=arguments-differ
    def list_object_versions(self) -> None:
        pass

    # pylint: disable=arguments-differ
    def list_objects(self) -> None:
        pass

    # pylint: disable=arguments-differ
    def list_objects_v2(self) -> None:
        pass

    # pylint: disable=arguments-differ
    def list_parts(self) -> None:
        pass

    # pylint: disable=arguments-differ
    def put_bucket_accelerate_configuration(
        self, Bucket: str, AccelerateConfiguration: Dict[str, Any]
    ) -> None:
        pass

    # pylint: disable=arguments-differ
    def put_bucket_acl(
        self,
        Bucket: str,
        ACL: str = None,
        AccessControlPolicy: Dict[str, Any] = None,
        GrantFullControl: str = None,
        GrantRead: str = None,
        GrantReadACP: str = None,
        GrantWrite: str = None,
        GrantWriteACP: str = None,
    ) -> None:
        pass

    # pylint: disable=arguments-differ
    def put_bucket_analytics_configuration(
        self, Bucket: str, Id: str, AnalyticsConfiguration: Dict[str, Any]
    ) -> None:
        pass

    # pylint: disable=arguments-differ
    def put_bucket_cors(self, Bucket: str, CORSConfiguration: Dict[str, Any]) -> None:
        pass

    # pylint: disable=arguments-differ
    def put_bucket_encryption(
        self,
        Bucket: str,
        ServerSideEncryptionConfiguration: Dict[str, Any],
        ContentMD5: str = None,
    ) -> None:
        pass

    # pylint: disable=arguments-differ
    def put_bucket_inventory_configuration(
        self, Bucket: str, Id: str, InventoryConfiguration: Dict[str, Any]
    ) -> None:
        pass

    # pylint: disable=arguments-differ
    def put_bucket_lifecycle(
        self, Bucket: str, LifecycleConfiguration: Dict[str, Any] = None
    ) -> None:
        pass

    # pylint: disable=arguments-differ
    def put_bucket_lifecycle_configuration(
        self, Bucket: str, LifecycleConfiguration: Dict[str, Any] = None
    ) -> None:
        pass

    # pylint: disable=arguments-differ
    def put_bucket_logging(
        self, Bucket: str, BucketLoggingStatus: Dict[str, Any]
    ) -> None:
        pass

    # pylint: disable=arguments-differ
    def put_bucket_metrics_configuration(
        self, Bucket: str, Id: str, MetricsConfiguration: Dict[str, Any]
    ) -> None:
        pass

    # pylint: disable=arguments-differ
    def put_bucket_notification(
        self, Bucket: str, NotificationConfiguration: Dict[str, Any]
    ) -> None:
        pass

    # pylint: disable=arguments-differ
    def put_bucket_notification_configuration(
        self, Bucket: str, NotificationConfiguration: Dict[str, Any]
    ) -> None:
        pass

    # pylint: disable=arguments-differ
    def put_bucket_policy(self) -> None:
        pass

    # pylint: disable=arguments-differ
    def put_bucket_replication(
        self, Bucket: str, ReplicationConfiguration: Dict[str, Any], Token: str = None
    ) -> None:
        pass

    # pylint: disable=arguments-differ
    def put_bucket_request_payment(
        self, Bucket: str, RequestPaymentConfiguration: Dict[str, Any]
    ) -> None:
        pass

    # pylint: disable=arguments-differ
    def put_bucket_tagging(self, Bucket: str, Tagging: Dict[str, Any]) -> None:
        pass

    # pylint: disable=arguments-differ
    def put_bucket_versioning(
        self, Bucket: str, VersioningConfiguration: Dict[str, Any], MFA: str = None
    ) -> None:
        pass

    # pylint: disable=arguments-differ
    def put_bucket_website(
        self, Bucket: str, WebsiteConfiguration: Dict[str, Any]
    ) -> None:
        pass

    # pylint: disable=arguments-differ
    def put_object(
        self,
        Bucket: str,
        Key: str,
        ACL: str = None,
        Body: Union[bytes, IO] = None,
        CacheControl: str = None,
        ContentDisposition: str = None,
        ContentEncoding: str = None,
        ContentLanguage: str = None,
        ContentLength: int = None,
        ContentMD5: str = None,
        ContentType: str = None,
        Expires: datetime = None,
        GrantFullControl: str = None,
        GrantRead: str = None,
        GrantReadACP: str = None,
        GrantWriteACP: str = None,
        Metadata: Dict[str, Any] = None,
        ServerSideEncryption: str = None,
        StorageClass: str = None,
        WebsiteRedirectLocation: str = None,
        SSECustomerAlgorithm: str = None,
        SSECustomerKey: str = None,
        SSECustomerKeyMD5: str = None,
        SSEKMSKeyId: str = None,
        SSEKMSEncryptionContext: str = None,
        RequestPayer: str = None,
        Tagging: str = None,
        ObjectLockMode: str = None,
        ObjectLockRetainUntilDate: datetime = None,
        ObjectLockLegalHoldStatus: str = None,
    ) -> Dict[str, Any]:
        pass

    # pylint: disable=arguments-differ
    def put_object_acl(
        self,
        Bucket: str,
        Key: str,
        ACL: str = None,
        AccessControlPolicy: Dict[str, Any] = None,
        GrantFullControl: str = None,
        GrantRead: str = None,
        GrantReadACP: str = None,
        GrantWrite: str = None,
        GrantWriteACP: str = None,
        RequestPayer: str = None,
        VersionId: str = None,
    ) -> Dict[str, Any]:
        pass

    # pylint: disable=arguments-differ
    def put_object_legal_hold(
        self,
        Bucket: str,
        Key: str,
        LegalHold: Dict[str, Any] = None,
        RequestPayer: str = None,
        VersionId: str = None,
        ContentMD5: str = None,
    ) -> Dict[str, Any]:
        pass

    # pylint: disable=arguments-differ
    def put_object_lock_configuration(
        self,
        Bucket: str,
        ObjectLockConfiguration: Dict[str, Any] = None,
        RequestPayer: str = None,
        Token: str = None,
        ContentMD5: str = None,
    ) -> Dict[str, Any]:
        pass

    # pylint: disable=arguments-differ
    def put_object_retention(
        self,
        Bucket: str,
        Key: str,
        Retention: Dict[str, Any] = None,
        RequestPayer: str = None,
        VersionId: str = None,
        BypassGovernanceRetention: bool = None,
        ContentMD5: str = None,
    ) -> Dict[str, Any]:
        pass

    # pylint: disable=arguments-differ
    def put_object_tagging(
        self,
        Bucket: str,
        Key: str,
        Tagging: Dict[str, Any],
        VersionId: str = None,
        ContentMD5: str = None,
    ) -> Dict[str, Any]:
        pass

    # pylint: disable=arguments-differ
    def put_public_access_block(
        self,
        Bucket: str,
        PublicAccessBlockConfiguration: Dict[str, Any],
        ContentMD5: str = None,
    ) -> None:
        pass

    # pylint: disable=arguments-differ
    def restore_object(
        self,
        Bucket: str,
        Key: str,
        VersionId: str = None,
        RestoreRequest: Dict[str, Any] = None,
        RequestPayer: str = None,
    ) -> Dict[str, Any]:
        pass

    # pylint: disable=arguments-differ
    def select_object_content(
        self,
        Bucket: str,
        Key: str,
        Expression: str,
        ExpressionType: str,
        InputSerialization: Dict[str, Any],
        OutputSerialization: Dict[str, Any],
        SSECustomerAlgorithm: str = None,
        SSECustomerKey: str = None,
        SSECustomerKeyMD5: str = None,
        RequestProgress: Dict[str, Any] = None,
        ScanRange: Dict[str, Any] = None,
    ) -> Dict[str, Any]:
        pass

    # pylint: disable=arguments-differ
    def upload_file(
        self,
        Filename: str = None,
        Bucket: str = None,
        Key: str = None,
        ExtraArgs: Dict[str, Any] = None,
        Callback: Callable[..., Any] = None,
        Config: TransferConfig = None,
    ) -> None:
        pass

    # pylint: disable=arguments-differ
    def upload_fileobj(
        self,
        Fileobj: Union[Any] = None,
        Bucket: str = None,
        Key: str = None,
        ExtraArgs: Dict[str, Any] = None,
        Callback: Callable[..., Any] = None,
        Config: TransferConfig = None,
    ) -> None:
        pass

    # pylint: disable=arguments-differ
    def upload_part(self) -> None:
        pass

    # pylint: disable=arguments-differ
    def upload_part_copy(
        self,
        Bucket: str,
        CopySource: Union[str, Dict[Any, Any]],
        Key: str,
        PartNumber: int,
        UploadId: str,
        CopySourceIfMatch: str = None,
        CopySourceIfModifiedSince: datetime = None,
        CopySourceIfNoneMatch: str = None,
        CopySourceIfUnmodifiedSince: datetime = None,
        CopySourceRange: str = None,
        SSECustomerAlgorithm: str = None,
        SSECustomerKey: str = None,
        SSECustomerKeyMD5: str = None,
        CopySourceSSECustomerAlgorithm: str = None,
        CopySourceSSECustomerKey: str = None,
        CopySourceSSECustomerKeyMD5: str = None,
        RequestPayer: str = None,
    ) -> Dict[str, Any]:
        pass
